codeforces148D(概率DP)

来源:互联网 发布:网络侵权案例 编辑:程序博客网 时间:2024/05/22 15:26

地址:http://codeforces.com/problemset/problem/148/D

D. Bag of mice
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

The dragon and the princess are arguing about what to do on the New Year's Eve. The dragon suggests flying to the mountains to watch fairies dancing in the moonlight, while the princess thinks they should just go to bed early. They are desperate to come to an amicable agreement, so they decide to leave this up to chance.

They take turns drawing a mouse from a bag which initially contains w white and b black mice. The person who is the first to draw a white mouse wins. After each mouse drawn by the dragon the rest of mice in the bag panic, and one of them jumps out of the bag itself (the princess draws her mice carefully and doesn't scare other mice). Princess draws first. What is the probability of the princess winning?

If there are no more mice in the bag and nobody has drawn a white mouse, the dragon wins. Mice which jump out of the bag themselves are not considered to be drawn (do not define the winner). Once a mouse has left the bag, it never returns to it. Every mouse is drawn from the bag with the same probability as every other one, and every mouse jumps out of the bag with the same probability as every other one.

Input

The only line of input data contains two integers w and b (0 ≤ w, b ≤ 1000).

Output

Output the probability of the princess winning. The answer is considered to be correct if its absolute or relative error does not exceed10 - 9.

Sample test(s)
input
1 3
output
0.500000000
input
5 5
output
0.658730159
Note

Let's go through the first sample. The probability of the princess drawing a white mouse on her first turn and winning right away is 1/4. The probability of the dragon drawing a black mouse and not winning on his first turn is 3/4 * 2/3 = 1/2. After this there are two mice left in the bag — one black and one white; one of them jumps out, and the other is drawn by the princess on her second turn. If the princess' mouse is white, she wins (probability is 1/2 * 1/2 = 1/4), otherwise nobody gets the white mouse, so according to the rule the dragon wins.


题意:抓老鼠,抓到白老鼠赢,问先手获胜的概率。

思路:这是第三道概率DP,不同于前两道,这一道题做时有些感觉,越做越像数位DP,尤其是本题用搜索来写。本题是回溯时求答案,因为尽管相同情况的不同种求法用记忆化搜索减少了运算,但是对于答案来说,每种情况都要计入在内,所以只用记忆化会多省一些数据。

代码:

#include<cstdio>#include<cstring>#include<iostream>#include<algorithm>using namespace std;double p[1010][1010];  //double型数组不能用memset全置为-1bool vis[1010][1010];  //所以这里开了个bool型辅助,这里坑了我半天double dfs(int w,int b)  //非常像数位DP搜索写法{    if(w<=0) return 0;    if(b<=0) return 1;    if(vis[w][b]) return p[w][b];    vis[w][b]=1;    double ans=w*1.0/(w+b);    if(w&&b>1)    {        double s;        s=1.0*b*(b-1)/(w+b)/(w+b-1);        ans+=s*((b-2)*1.0/(w+b-2)*dfs(w,b-3)+w*1.0/(w+b-2)*dfs(w-1,b-2));    }    p[w][b]=ans;    return ans;}int main(){    int w,b;    scanf("%d%d",&w,&b);    printf("%.9f\n",dfs(w,b));    return 0;}


0 0